//
//      AWSSAXParser.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

#include "AWSSAXParser.hpp"

// Constructor
AWSSAXParser::AWSSAXParser(SFXAnsiStringConstRef productgroup) 
{
	_productgroup = productgroup;
	_tracerStack = new TracerTypeStack();
    return;
}

// Destructor
AWSSAXParser::~AWSSAXParser(Void)
{
    return;
}

Void AWSSAXParser::DoCommandEntry(SFXAnsiString param, pt2AWSProductMember method, VoidPtr reference)
{
	AWSSAXParserPtr(reference)->DoCommand(param, method);
}

Void AWSSAXParser::DoCommand(SFXAnsiString param, pt2AWSProductMember method)
{
	// set the method to call
	_pt2Member = method;
	// call the corresponding method of AWSProduct
    if (_product!=null)(_product->*_pt2Member)(param);
}

Void AWSSAXParser::StartDocument(Void)
{
	// create a list of product
	_products = ::new AWSListProducts();
	return;
}

Void AWSSAXParser::Characters(SFXAnsiStringConstRef string, BoolConst /*cdataSection*/)
{
	// store the characters data in _data variable
	_data.Set(string);
	return;
}

Void AWSSAXParser::StartElement(SFXAnsiStringConstRef uri, SFXAnsiStringConstRef localname, SFXAnsiStringConstRef qname, SFXXMLGrammar::XMLAttrListConstRef attrList)
{
	// reset the _data variable
	_data.SetLength(0);
	
	// create a product
	if(qname == "Item") 
		_product = AWSProduct::Factory(_productgroup);

	// get the top tag tracer from the stack	
	TagTracerPtr activeTracer = _tracerStack->Peek();
	// delegate the event handling to the tagtracer
	activeTracer->OnStart(qname, _tracerStack, DoCommandEntry, this);

	return;
}

Void AWSSAXParser::EndElement(SFXAnsiStringConstRef uri, SFXAnsiStringConstRef localname, SFXAnsiStringConstRef qname)
{
	// get the top tag tracer from the stack
	TagTracerPtr activeTracer = _tracerStack->Peek();
	// delegate the event handling to the tagtracer
	activeTracer->OnEnd(_tracerStack, _data, DoCommandEntry, this);
	
	// add the product to the list of products
	if(qname == "Item")
		_products->AddProduct(_product);
	
	return;
}

Void AWSSAXParser::EndDocument(Void)
{
	return;
}


Void AWSSAXParser::IgnorableWhitespace(SFXAnsiStringConstRef string)
{
	return;
}

Void AWSSAXParser::ProcessingInstruction(SFXAnsiStringConstRef target, SFXAnsiStringConstRef data)
{
	return;
}

Void AWSSAXParser::StartPrefixMapping(SFXAnsiStringConstRef  prefix, SFXAnsiStringConstRef uri)
{
	return;
}

Void AWSSAXParser::EndPrefixMapping(SFXAnsiStringConstRef  prefix)
{
	return;
}

Void AWSSAXParser::Comment(SFXAnsiStringConstRef string)
{
	return;
}

Void AWSSAXParser::StartCDATA(Void)
{
	return;
}

Void AWSSAXParser::EndCDATA(Void)
{
	return;
}

Void AWSSAXParser::StartDTD(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId)
{
	return;
}

Void AWSSAXParser::EndDTD(Void)
{
	return;
}

Void AWSSAXParser::StartEntity(SFXAnsiStringConstRef name)
{
	return;
}

Void AWSSAXParser::EndEntity(SFXAnsiStringConstRef name)
{
	return;
}

Void AWSSAXParser::NotationDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId)
{
	return;
}

Void AWSSAXParser::UnparsedEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId, SFXAnsiStringConstRef notationName)
{
	return;
}

Void AWSSAXParser::ElementDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef model)
{
	return;
}

Void AWSSAXParser::AttributeDecl(SFXAnsiStringConstRef ename, SFXAnsiStringConstRef aname, SFXAnsiStringConstRef type, SFXAnsiStringConstRef mode, SFXAnsiStringConstRef value)
{
	return;
}

Void AWSSAXParser::InternalEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef value)
{
	return;
}

Void AWSSAXParser::ExternalEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId)
{
	return;
}

Void AWSSAXParser::ErrorReport(SFCErrorConst error, SFXAnsiStringConstRef errInfo)
{
	return;
}