//
//      SGXListProducts.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

/**
***	Project         : Amazon Products Viewing
***	File			: AWSSAXParser.hpp	
***	Description		: SAX Parser handler class
**/

#ifndef __AWSSAXParser_HPP
#define __AWSSAXParser_HPP

#include <SophiaFramework.hpp>
#include "AWSListProducts.hpp"
#include "TagTracer.hpp"

SFMTYPEDEFCLASS(AWSSAXParser)
class AWSSAXParser : public SFXXMLDefaultHandler{
SFMSEALCOPY(AWSSAXParser)

private:
	TracerTypeStackPtr	_tracerStack;	// stack to keep the tag tracers
	SFXAnsiString		_data;			// character data

private:
	SFXAnsiString		_productgroup;	 // product group such as Books or DVD
	AWSProductPtr		_product;		 // a AWSProduct	
	AWSListProductsPtr  _products;		 // a list of products 

	pt2AWSProductMember _pt2Member;		 // pointer to a method of AWSProduct class
public:
	// constructor
    AWSSAXParser(SFXAnsiStringConstRef productgroup);
	// destructor
    virtual		~AWSSAXParser(Void);
	
	// push the root of the trace map into the stack
	// all future tag tracing will follow the paths from this root in the trace map 
	void SetRoot(TagTracerPtr root){_tracerStack->Push(root);};
	// return list of products (parsing result)
	AWSListProductsPtr GetProducts(Void){return _products;}		
	// (callback function) entry point for DoCommand function
	static Void DoCommandEntry(SFXAnsiString param, pt2AWSProductMember method, VoidPtr reference); 
	// call the corresponding method of AWSProduct class
	void DoCommand(SFXAnsiString param, pt2AWSProductMember method);

public:
	virtual Void StartDocument(Void);
	virtual Void Characters(SFXAnsiStringConstRef string, BoolConst cdataSection = true);
	virtual Void StartElement(SFXAnsiStringConstRef uri, SFXAnsiStringConstRef localname, SFXAnsiStringConstRef qname, SFXXMLGrammar::XMLAttrListConstRef attrList);
	virtual Void EndElement(SFXAnsiStringConstRef uri = "", SFXAnsiStringConstRef localname = "", SFXAnsiStringConstRef qname = "");

	// interface for ContentHandler
    virtual Void EndDocument(Void);
    virtual Void IgnorableWhitespace(SFXAnsiStringConstRef string);
    virtual Void ProcessingInstruction(SFXAnsiStringConstRef target, SFXAnsiStringConstRef data);
    virtual Void EndPrefixMapping(SFXAnsiStringConstRef prefix);
    virtual Void StartPrefixMapping(SFXAnsiStringConstRef prefix, SFXAnsiStringConstRef uri);

    // interface for LexicalHandler
    virtual Void Comment(SFXAnsiStringConstRef string);
    virtual Void EndCDATA(Void);
    virtual Void EndDTD(Void);
    virtual Void EndEntity(SFXAnsiStringConstRef name);
    virtual Void StartCDATA(Void);
    virtual Void StartDTD(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId);
    virtual Void StartEntity(SFXAnsiStringConstRef name);

    // interface for DTDHandler
    virtual Void NotationDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId);
    virtual Void UnparsedEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId, SFXAnsiStringConstRef notationName);

    // interface for DeclHandler
    virtual Void ElementDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef model);
    virtual Void AttributeDecl(SFXAnsiStringConstRef ename, SFXAnsiStringConstRef aname, SFXAnsiStringConstRef type, SFXAnsiStringConstRef mode, SFXAnsiStringConstRef value);
    virtual Void InternalEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef value);
    virtual Void ExternalEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId);

    // others functions
    virtual Void ErrorReport(SFCErrorConst error, SFXAnsiStringConstRef errInfo); 
};

#endif // __AWSSAXParser_HPP //
