//
//      ListProductsWindow.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//
#include "pself3.hpp"
#include "pself3_res.h"
#include "ListProductsWindow.hpp"
#include "SGRSoftkeyWindow.hpp"
#include "SGRSoftkeyToolbox.hpp"

enum {
    OPERATION_REMOVE,
    OPERATION_REMOVEALL,
    OPERATION_RETURN,
    OPERATION_LIMIT
};

ListProductsWindow::ListProductsWindow(AWSListProductsPtr products, SFXAnsiStringConstRef searchindex, SInt16 windowtype) static_throws : 
	SFRPlainWindow(SFRApplication::GetInstance(), SGRSoftkeyToolbox::GetWindowPosition(), BEHAVIOR_SFRPLAINWINDOW, ATTRIBUTE_LISTPRODUCTSWINDOW),
	_products(products),
	_searchindex(searchindex), 
	_windowtype(windowtype)
{
    SGRSoftkeyWindowPtr softkey;
    SFXRectangle rect;
    UInt16 i;

    SGRSoftkeyWindow::Initialize(this);

    if (!static_try()) return; 
	
    // drawing handler registering
    static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE, HANDLER_FUNCTION(OnRender)));
    if (!static_try()) return; 
		
    // softkey handler register
    static_throw(RegisterHandler(static_cast<SFCEventEnum>(SGRSoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
    if (!static_try()) return;

	// calculate the drawing area for the list
	rect = GetContentWorld();
	rect.AddTop(SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) + FONT_MARGIN);
	rect.Deflate(LISTBOX_MARGIN, LISTBOX_MARGIN);

	// Create list box control

    if ((_list = ::new SGRListboxControl(this, rect)) == null) return;

    static_throw(*_list);
    if (!static_try())
	{
		static_throw(SFERR_NO_MEMORY);
		return;
	}

    // list box handler registering

    static_throw(_list->RegisterHandler(SREVT_CONTROL, HANDLER_AFTER, HANDLER_FUNCTION(OnControl)));
    if (!static_try()) return;

    // softkey registering
	if ((softkey = SGRSoftkeyWindow::GetInstance()) == null) return;
	
    static_throw(softkey->Register(this, SGRSoftkeyWindow::SOFTKEY_1, "End"));
    if (!static_try()) return;

    static_throw(softkey->Register(this, SGRSoftkeyWindow::SOFTKEY_2, (_windowtype == 0)? "Back" : "Menu"));
    if (!static_try()) return;
                                        
	static_throw(softkey->Register(this, SGRSoftkeyWindow::SOFTKEY_3, "Detail"));
    if (!static_try()) return;
    
	SetReference(softkey->Bind(this));
    if (!static_try()) return;
	
	//Populate the list
	UInt16 size = _products->GetSize(); 
    for (i = 0;  i < size ; i++) 
	{
		SFXAnsiStringConstRef title = _products->GetProduct(i)->GetTitle();
        _list->Append(title);
    }

    return;
}

ListProductsWindow::~ListProductsWindow(Void)
{
    SGRSoftkeyWindow::Terminate(this);

	_searchindex.Clear();
	
	if (_products != null)
	{
		delete _products;
		_products = null;
	}

	if (_list != null)
	{
		delete _list;
		_list = null;
	}

    return;
}

// Drawing handler
HANDLER_IMPLEMENT_VOIDRENDER(ListProductsWindow, OnRender, graphics)
{
    static SFXBevelColor::AtomRecConst theme[] = {
        {
            {0x00, 0xFF, 0xFF, 0xFF},
            {0x00, 0xCC, 0xCC, 0xCC},
            {0x00, 0x88, 0x88, 0x88}
        },
        {
            {0x00, 0xFF, 0xFF, 0xFF},
            {0x00, 0xEE, 0xEE, 0xEE},
            {0x00, 0x88, 0x88, 0x88}
        }
    };
    static SFXRGBColor::AtomRecConst black = {
        0x00, 0x00, 0x00, 0x00
    };
    SFXRectangle top;
    SFXRectangle bottom(GetContentWorld());

    top = bottom;
    top.SetHeight(graphics->GetFontHeight() + FONT_MARGIN);
    graphics->FillBevelHorizontal(top, theme[0]);

	 // display title
	if (_windowtype == SEARCHWINDOW)
		graphics->DrawText("Search Result", top, black);
    else if (_windowtype == FAVORITEWINDOW)
		graphics->DrawText("Favorites", top, black);

	bottom.SetTop(top.GetBottom());
    graphics->FillBevelHorizontal(bottom, theme[1]);
    return;
}

// list selected item handler
HANDLER_IMPLEMENT_VOIDCONTROL(ListProductsWindow, OnControl, result, control)
{
    unused(control);

    SFCError error(SFERR_NO_ERROR);

	SFXHelper::dbgprintf("--------------------XML");


    switch (result) {
		case SRP16_ESCAPE:
            // destroy this window
            Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
            break;
        default:
            // display product information
			SFXWideString string;
			SFRMultiDialog::ParamRec param;
			Bool b;

			string = _products->GetProduct(_list->GetSelect())->GetAsin();

			SFXPathConst filename(DIR_NAME + string + ".xml");

			SFXFile::Exists(filename, &b);
			if (!b)
				//if this product not exists then connect to AWS to get information
				_networkDialog.Open(AWSProduct::GetUrlForItemLookup(string), true, OnNetworkEntry, this, "Confirm", "Connect to internet?", "Yes", "No" );
		    else 
			{
				//load product information from XML file
				AWSListProductsPtr	_listoneproduct;

				_listoneproduct = ::new AWSListProducts();
				if(_listoneproduct == null) return;

				// parse xml file using SAXParser
				AWSSAXParser			_parser(_searchindex);
				SFXXMLSAXParser			saxparser;
				
				// make the trace map to get product information from xml file
				_parser.SetRoot(NewTraceMap(_searchindex));
				saxparser.SetDefaultHandler(&_parser);

				// parse the xml file
				saxparser.Parse(filename);

				// the xml file contains only 1 product, display the product information
				_parser.GetProducts()->GetProduct(0)->DisplayMe(_searchindex, EXIST_FAVORITE);

			}
	        break;
    }
    return;
}

// softkey handler
HANDLER_IMPLEMENT_VOIDEVENT(ListProductsWindow, OnSoftkey, event)
{
    SFCError error(SFERR_NO_ERROR);

    switch (event.GetP16()) 
	{
        case SGRSoftkeyWindow::SOFTKEY_1:
			// terminate application
			SFRApplication::Terminate();
            break;
        case SGRSoftkeyWindow::SOFTKEY_2:
			// if this is search result window then close it	
			if (_windowtype == SEARCHWINDOW)
				Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
			else if (_windowtype == FAVORITEWINDOW)
			{// create a menu for favorite window
				SFRTextMenuPtr menu;
				
				if ((menu = ::new SFRTextMenu(SGRSoftkeyToolbox::GetMenuPosition(OPERATION_LIMIT), "Menu", null, 0)) == null)
				return;

                if ((error = menu->static_catch()) != SFERR_NO_ERROR)
				{
					delete menu;
					return;
				}
                
				if ((error = menu->AppendItem("Delete", AVK_1, 0xFBF6)) == SFERR_NO_ERROR)
					if ((error = menu->AppendItem("Delete All", AVK_2, 0xFCF6)) == SFERR_NO_ERROR)
						if ((error = menu->AppendItem("Back", AVK_3, 0x40F7)) == SFERR_NO_ERROR)
							error = SGRSoftkeyToolbox::OpenStandardMenu(menu, HANDLER_FUNCTION(FromSoftkey));
                                        
                if (error != SFERR_NO_ERROR) ::delete menu;
                
			}
            break;
    }
    return;
}
// menu items handler
HANDLER_IMPLEMENT_VOIDMENU(ListProductsWindow, FromSoftkey, result, menu)
{
    SFRMultiDialogPtr dialog;
    SFRMultiDialog::ParamRec param;
    SFXWideString title;
	SInt32 titlelength; 

    switch (result) {
        case OPERATION_REMOVE: // delete selected item

			// close menu
			SGRSoftkeyToolbox::CloseStandardMenu(menu);
			
			if(_list->GetItemCount()<=0) return;

			title = _products->GetProduct(_list->GetSelect())->GetTitle();

			titlelength = title.GetLength();

			if( titlelength != 0)
			{
				// parameters for dialog
				param.text = "Delete \"" + title + "\"H";
				param.ok = "Yes";
				param.cancel = "Cancel";
				param.focus = SFRMultiDialog::FOCUS_CANCEL;
				param.image = SFBShell::GetInstance()->LoadResImage(PSELF3_RES_FILE, ACCEPT);
					
				// create dialog

				if ((dialog = ::new SFRMultiDialog(SGRSoftkeyToolbox::GetDialogPosition(SFRMultiDialog::GetMargin(), MULTIDIALOG_REMOVE_HEIGHT), "Confirm", param)) != null)
					SGRSoftkeyToolbox::OpenStandardDialog(dialog, HANDLER_FUNCTION(FromRemove));
			}
			break;
        case OPERATION_REMOVEALL: // delete all items
			
			// close menu
			SGRSoftkeyToolbox::CloseStandardMenu(menu);

			if(_list->GetItemCount()>0){

				// parameters for dialog
				param.text = "Are you sure you want to delete all?";
				param.ok = "Yes";
				param.cancel = "Cancel";
				param.focus = SFRMultiDialog::FOCUS_CANCEL;
				param.image = SFBShell::GetInstance()->LoadResImage(PSELF3_RES_FILE, ACCEPT);

				// create dialog
				if ((dialog = ::new SFRMultiDialog(SGRSoftkeyToolbox::GetDialogPosition(SFRMultiDialog::GetMargin(), MULTIDIALOG_REMOVEALL_HEIGHT), "mF", param)) != null) 
					SGRSoftkeyToolbox::OpenStandardDialog(dialog, HANDLER_FUNCTION(FromRemoveAll));
				
			}
            break;

        case OPERATION_RETURN:
            // close menu
            SGRSoftkeyToolbox::CloseStandardMenu(menu);
            // destroy this window
            Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
            break;

        case SRP16_ESCAPE:
        case SRP16_CANCEL:
            // close menu
            SGRSoftkeyToolbox::CloseStandardMenu(menu);
            break;
    }
    return;
}

// "Delete" is selected and button is pressed handler 
HANDLER_IMPLEMENT_VOIDDIALOG(ListProductsWindow, FromRemove, result, dialog)
{
    SFRMultiDialogPtr dialog2;
    SFRMultiDialog::ParamRec param;

    switch (result) {
        case SRP16_OK: // if Yes
            // Close dialog
            SGRSoftkeyToolbox::CloseStandardDialog(dialog);

            // delete a product from list of products and delete related files
			_products->RemoveProduct(_products->GetProduct(_list->GetSelect())->GetAsin());

			// update favorite file
			_products->UpdateFavoriteFile(SFXPath(DIR_NAME + _searchindex + ".dat"));

            // delete from list
			if (_products->GetSize()<=0)
				_list->Clear();
			else
				_list->Remove(_list->GetSelect());

			// dialog parameters
			param.text = "Deleted";
			param.ok = "OK";
			param.cancel = "";
			param.focus = SFRMultiDialog::FOCUS_OK;
			param.image = SFBImageSmp(null);         // icon image

			// create dialog
			dialog2 = ::new SFRMultiDialog(	SGRSoftkeyToolbox::GetWindowPosition().Deflate(20, 0)
							.SetHeight(100).AddY(80),"Delete Message", param);

			if (dialog2 != null) 
				dialog2->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE, HANDLER_FUNCTION(OnDialog));
                
            break;
        case SRP16_ESCAPE: 
        case SRP16_CANCEL: 
            // close dialog
            SGRSoftkeyToolbox::CloseStandardDialog(dialog);
            break;
    }
    return;
}

// "Delete All" is selected and button is pressed handler 
HANDLER_IMPLEMENT_VOIDDIALOG(ListProductsWindow, FromRemoveAll, result, dialog)
{
    SFRMultiDialogPtr dialog2;
    SFRMultiDialog::ParamRec param;

    switch (result) {
        case SRP16_OK: // If Yes
            SGRSoftkeyToolbox::CloseStandardDialog(dialog);

            // delete all products from product list and related files
			_products->RemoveAllProducts();

			// delete favorite
			SFXFile::Remove(SFXPath(DIR_NAME + _searchindex + ".dat"));
			
			// clear the list
			_list->Clear();

			// dialog parameters
			param.text = "All deleted";
			param.ok = "OK";
			param.cancel = "";
			param.focus = SFRMultiDialog::FOCUS_OK;
			param.image = SFBImageSmp(null);         // icon image

			// create dialog
			dialog2 = ::new SFRMultiDialog(SGRSoftkeyToolbox::GetWindowPosition().Deflate(20, 0)
							.SetHeight(100).AddY(80),"Delete Message", param);

            if (dialog2 != null) 
                    dialog2->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE, HANDLER_FUNCTION(OnDialog));

            break;

        case SRP16_ESCAPE:
        case SRP16_CANCEL: 
            // close dialog
            SGRSoftkeyToolbox::CloseStandardDialog(dialog);
            break;
    }
    return;
}


// button on "Deleted" dialog is pressed handler
HANDLER_IMPLEMENT_VOIDDIALOG(ListProductsWindow, OnDialog, result, dialog)
{
    unused(result);

    // destroy itself
     dialog->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));

}

Void ListProductsWindow::OnNetworkEntry(SGRNetworkDialogSet::NotifyEnum notify, SFCError error, VoidPtr reference)
{
    ListProductsWindowPtr(reference)->OnNetwork(notify, error);
}

Void ListProductsWindow::OnNetwork(SGRNetworkDialogSet::NotifyEnum notify, SFCError error)
{
    unused(error);

    switch(notify) {
        case SGRNetworkDialogSet::NOTIFY_CONNECT_END:
            error = ParseXML();
			if(error != SFERR_NO_ERROR)
				_errorDialog.Open(XML_ERROR_TITLE, GetErrMsg(), DIALOG_OK, this);
			break;
		default:
			break;
    }	

	return;
}

// new tracemap for retriving product information from xml file
TagTracerPtr ListProductsWindow::NewTraceMap(SFXAnsiStringConstRef searchindex)
{
	//root
	TagTracerPtr root = new TagTracer();
	//root->ItemLookupResponse
	TagTracerPtr ItemLookupResponse = new TagTracer();
	root->Trace("ItemLookupResponse", ItemLookupResponse);
	//root->ItemLookupResponse->Items
	TagTracerPtr Items = new TagTracer();
	ItemLookupResponse->Trace("Items", Items);
	//root->ItemLookupResponse->Items->item
	TagTracerPtr Item = new TagTracer();
	Items->Trace("Item", Item);
	//root->ItemLookupResponse->Items->item->ASIN
	TagTracerPtr ASIN = new TagTracer(&AWSProduct::SetAsin);
	Item->Trace("ASIN", ASIN);
	
	//root->ItemLookupResponse->Items->item->MediumImage
	TagTracerPtr MediumImage = new TagTracer(&AWSProduct::NewImageUrl, &AWSProduct::DoNothing);
	Item->Trace("MediumImage", MediumImage);
	//root->ItemLookupResponse->Items->item->MediumImage->URL
	TagTracerPtr URL = new TagTracer(&AWSProduct::SetMediumImageURL);
	MediumImage->Trace("URL", URL);
	
	//root->ItemLookupResponse->Items->item->ItemAttributes
	TagTracerPtr ItemAttributes = new TagTracer(&AWSProduct::NewItemAttributes, &AWSProduct::DoNothing);
	Item->Trace("ItemAttributes", ItemAttributes);
	//root->ItemLookupResponse->Items->item->ItemAttributes->Title
	TagTracerPtr Title = new TagTracer(&AWSProduct::SetTitle);
	ItemAttributes->Trace("Title", Title);
	
	if (searchindex == BOOK_SEARCH)
	{

		//root->ItemLookupResponse->Items->item->ItemAttributes->Author
		TagTracerPtr Author = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("Author", Author);
		//root->ItemLookupResponse->Items->item->ItemAttributes->Binding
		TagTracerPtr Binding = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("Binding", Binding);
		//root->ItemLookupResponse->Items->item->ItemAttributes->NumberOfPages
		TagTracerPtr NumberOfPages = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("NumberOfPages", NumberOfPages);
		//root->ItemLookupResponse->Items->item->ItemAttributes->PublicationDate
		TagTracerPtr PublicationDate = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("PublicationDate", PublicationDate);
		//root->ItemLookupResponse->Items->item->ItemAttributes->Publisher
		TagTracerPtr Publisher = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("Publisher", Publisher);
		//root->ItemLookupResponse->Items->item->ItemAttributes->ListPrice
		TagTracerPtr ListPrice = new TagTracer();
		ItemAttributes->Trace("ListPrice", ListPrice);
		//root->ItemLookupResponse->Items->item->ItemAttributes->ListPrice->Amount
		TagTracerPtr Amount = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ListPrice->Trace("Amount", Amount);
		//root->ItemLookupResponse->Items->item->ItemAttributes->ListPrice->CurrencyCode
		TagTracerPtr CurrencyCode = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ListPrice->Trace("CurrencyCode", CurrencyCode);
		//root->ItemLookupResponse->Items->item->ItemAttributes->ListPrice->FormattedPrice
		TagTracerPtr FormattedPrice = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ListPrice->Trace("FormattedPrice", FormattedPrice);
	}
	else if (searchindex == DVD_SEARCH)
	{
		//root->ItemLookupResponse->Items->item->ItemAttributes->Actor
		TagTracerPtr Actor = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("Actor", Actor);
		//root->ItemLookupResponse->Items->item->ItemAttributes->Directors
		TagTracerPtr Director = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("Director", Director);
		//root->ItemLookupResponse->Items->item->ItemAttributes->Format
		TagTracerPtr Format = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("Format", Format);
		//root->ItemLookupResponse->Items->item->ItemAttributes->ReleaseDate
		TagTracerPtr ReleaseDate = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("ReleaseDate", ReleaseDate);
		//root->ItemLookupResponse->Items->item->ItemAttributes->Publisher
		TagTracerPtr Publisher = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("Publisher", Publisher);
		//root->ItemLookupResponse->Items->item->ItemAttributes->RunningTime
		TagTracerPtr RunningTime = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ItemAttributes->Trace("RunningTime", RunningTime);
		//root->ItemLookupResponse->Items->item->ItemAttributes->ListPrice
		TagTracerPtr ListPrice = new TagTracer();
		ItemAttributes->Trace("ListPrice", ListPrice);
		//root->ItemLookupResponse->Items->item->ItemAttributes->ListPrice->Amount
		TagTracerPtr Amount = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ListPrice->Trace("Amount", Amount);
		//root->ItemLookupResponse->Items->item->ItemAttributes->ListPrice->CurrencyCode
		TagTracerPtr CurrencyCode = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ListPrice->Trace("CurrencyCode", CurrencyCode);
		//root->ItemLookupResponse->Items->item->ItemAttributes->ListPrice->FormattedPrice
		TagTracerPtr FormattedPrice = new TagTracer(&AWSProduct::SetFlag, &AWSProduct::SetItemAttributes);
		ListPrice->Trace("FormattedPrice", FormattedPrice);
	}

	//root->ItemLookupResponse->Items->item->CustomerReviews
	TagTracerPtr CustomerReviews = new TagTracer(&AWSProduct::NewCustomerReviews, &AWSProduct::DoNothing);
	Item->Trace("CustomerReviews", CustomerReviews);
	//root->ItemLookupResponse->Items->item->CustomerReviews->AverageRating
	TagTracerPtr AverageRating = new TagTracer(&AWSProduct::SetCRAverageRating);
	CustomerReviews->Trace("AverageRating", AverageRating);
	//root->ItemLookupResponse->Items->item->CustomerReviews->Review
	TagTracerPtr Review = new TagTracer(&AWSProduct::NewReview, &AWSProduct::SetReview);
	CustomerReviews->Trace("Review", Review);
	//root->ItemLookupResponse->Items->item->CustomerReviews->Review->Rating
	TagTracerPtr Rating = new TagTracer(&AWSProduct::SetReviewRating);
	Review->Trace("Rating", Rating);
	//root->ItemLookupResponse->Items->item->CustomerReviews->Review->Summary
	TagTracerPtr Summary = new TagTracer(&AWSProduct::SetReviewSummary);
	Review->Trace("Summary", Summary);
	//root->ItemLookupResponse->Items->item->CustomerReviews->Review->Summary
	TagTracerPtr Content = new TagTracer(&AWSProduct::SetReviewContent);
	Review->Trace("Content", Content);

	//root->ItemLookupResponse->Items->item->SimilarProducts
	TagTracerPtr SimilarProducts = new TagTracer(&AWSProduct::NewSimilarProducts, &AWSProduct::DoNothing);
	Item->Trace("SimilarProducts", SimilarProducts);
	//root->ItemLookupResponse->Items->item->SimilarProducts->SimilarProduct
	TagTracerPtr SimilarProduct = new TagTracer(&AWSProduct::NewSimilarProduct, &AWSProduct::SetSimilarProduct);
	SimilarProducts->Trace("SimilarProduct", SimilarProduct);
	//root->ItemLookupResponse->Items->item->SimilarProducts->SimilarProduct->ASIN
	TagTracerPtr SPASIN = new TagTracer(&AWSProduct::SetSimilarProductAsin);
	SimilarProduct->Trace("ASIN", SPASIN);
	//root->ItemLookupResponse->Items->item->SimilarProducts->SimilarProduct->Title
	TagTracerPtr SPTitle = new TagTracer(&AWSProduct::SetSimilarProductTitle);
	SimilarProduct->Trace("Title", SPTitle);
	
	return root;
}

SFCError ListProductsWindow::ParseXML(Void)
{
    SFCError error = SFERR_NO_ERROR;

    SFXBuffer _xmldata;

    SFXFile file;
 	
	//get xml file name
	SFXPathConst filename(DIR_NAME + _products->GetProduct(_list->GetSelect())->GetAsin() + ".xml");

	// convert the text to sjis and store in str
	_xmldata = _networkDialog.GetData();
		
	// clear the text
	_networkDialog.ClearData();

	// delete the file before writing
	SFXFile::Remove(filename);

	// open XML file in readwrite mode
	error = file.OpenReadWrite(filename);
	if (error != SFERR_NO_ERROR) 
	{
		_errmsg = "Cannot open XML file!";
		return error;
	}
	
	SFXBinaryStreamWriter writer;

	// get the writing stream
	// 1st arg:	buffer size
	// 2nd arg:	pointer that store result 
	
	error = file.GetStreamWriter(_xmldata.GetSize(), &writer);
	if (error != SFERR_NO_ERROR) 
	{
		_errmsg = "GetStreamWriter failed!";
		return error;	
	}		

	// write str to the output stream
	error = writer.Write(_xmldata);
	if (error != SFERR_NO_ERROR) 
	{
		_errmsg = "Cannot write data to the output stream!";
		return error;
	}

	// flush the written data
	error = writer.Flush();
	if (error != SFERR_NO_ERROR)
	{
		_errmsg = "Flush failed!";
		return error;
	}

	// close file
	file.Close();

	// parse xml file using SAXParser to get product information
	AWSSAXParser			_parser(_searchindex);
	SFXXMLSAXParser			saxparser;

	_parser.SetRoot(NewTraceMap(_searchindex));

	saxparser.SetDefaultHandler(&_parser);
	error = saxparser.Parse(filename);
	if (error != SFERR_NO_ERROR) 
	{
		_errmsg = "Parsing failed!";
		return error;
	}

	// display product information

	error= _parser.GetProducts()->GetProduct(0)->DisplayMe(_searchindex, NOT_EXIST_FAVORITE);
 	if (error != SFERR_NO_ERROR) 
		_errmsg = "Cannot display data!";

    return error;
}


